dt: Document a compatible entry for MDIO ethernet Phys
[linux-2.6/btrfs-unstable.git] / scripts / link-vmlinux.sh
blob2dcb37736d8469a0e18e4c1ba262281e3fd8cf37
1 #!/bin/sh
3 # link vmlinux
5 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6 # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7 # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8 # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
10 # vmlinux
11 # ^
12 # |
13 # +-< $(KBUILD_VMLINUX_INIT)
14 # | +--< init/version.o + more
15 # |
16 # +--< $(KBUILD_VMLINUX_MAIN)
17 # | +--< drivers/built-in.o mm/built-in.o + more
18 # |
19 # +-< ${kallsymso} (see description in KALLSYMS section)
21 # vmlinux version (uname -v) cannot be updated during normal
22 # descending-into-subdirs phase since we do not yet know if we need to
23 # update vmlinux.
24 # Therefore this step is delayed until just before final link of vmlinux.
26 # System.map is generated to document addresses of all kernel symbols
28 # Error out on error
29 set -e
31 # Nice output in kbuild format
32 # Will be supressed by "make -s"
33 info()
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
40 # Link of vmlinux.o used for section mismatch analysis
41 # ${1} output file
42 modpost_link()
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
48 # Link of vmlinux
49 # ${1} - optional extra .o files
50 # ${2} - output file
51 vmlinux_link()
53 local lds="${objtree}/${KBUILD_LDS}"
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil ${1}
66 rm -f linux
71 # Create ${2} .o file with all symbols from the ${1} object file
72 kallsyms()
74 info KSYM ${2}
75 local kallsymopt;
77 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
81 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
82 kallsymopt="${kallsymopt} --all-symbols"
85 if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
89 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
90 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
92 ${NM} -n ${1} | \
93 scripts/kallsyms ${kallsymopt} | \
94 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
97 # Create map file with all symbols from ${1}
98 # See mksymap for additional details
99 mksysmap()
101 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
104 sortextable()
106 ${objtree}/scripts/sortextable ${1}
109 # Delete output files in case of error
110 trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
111 cleanup()
113 rm -f .old_version
114 rm -f .tmp_System.map
115 rm -f .tmp_kallsyms*
116 rm -f .tmp_version
117 rm -f .tmp_vmlinux*
118 rm -f System.map
119 rm -f vmlinux
120 rm -f vmlinux.o
125 # Use "make V=1" to debug this script
126 case "${KBUILD_VERBOSE}" in
127 *1*)
128 set -x
130 esac
132 if [ "$1" = "clean" ]; then
133 cleanup
134 exit 0
137 # We need access to CONFIG_ symbols
138 case "${KCONFIG_CONFIG}" in
139 */*)
140 . "${KCONFIG_CONFIG}"
143 # Force using a file from the current directory
144 . "./${KCONFIG_CONFIG}"
145 esac
147 #link vmlinux.o
148 info LD vmlinux.o
149 modpost_link vmlinux.o
151 # modpost vmlinux.o to check for section mismatches
152 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
154 # Update version
155 info GEN .version
156 if [ ! -r .version ]; then
157 rm -f .version;
158 echo 1 >.version;
159 else
160 mv .version .old_version;
161 expr 0$(cat .old_version) + 1 >.version;
164 # final build of init/
165 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
167 kallsymso=""
168 kallsyms_vmlinux=""
169 if [ -n "${CONFIG_KALLSYMS}" ]; then
171 # kallsyms support
172 # Generate section listing all symbols and add it into vmlinux
173 # It's a three step process:
174 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
175 # but __kallsyms is empty.
176 # Running kallsyms on that gives us .tmp_kallsyms1.o with
177 # the right size
178 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
179 # the right size, but due to the added section, some
180 # addresses have shifted.
181 # From here, we generate a correct .tmp_kallsyms2.o
182 # 2a) We may use an extra pass as this has been necessary to
183 # woraround some alignment related bugs.
184 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
185 # 3) The correct ${kallsymso} is linked into the final vmlinux.
187 # a) Verify that the System.map from vmlinux matches the map from
188 # ${kallsymso}.
190 kallsymso=.tmp_kallsyms2.o
191 kallsyms_vmlinux=.tmp_vmlinux2
193 # step 1
194 vmlinux_link "" .tmp_vmlinux1
195 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
197 # step 2
198 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
199 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
201 # step 2a
202 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
203 kallsymso=.tmp_kallsyms3.o
204 kallsyms_vmlinux=.tmp_vmlinux3
206 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
208 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
212 info LD vmlinux
213 vmlinux_link "${kallsymso}" vmlinux
215 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
216 info SORTEX vmlinux
217 sortextable vmlinux
220 info SYSMAP System.map
221 mksysmap vmlinux System.map
223 # step a (see comment above)
224 if [ -n "${CONFIG_KALLSYMS}" ]; then
225 mksysmap ${kallsyms_vmlinux} .tmp_System.map
227 if ! cmp -s System.map .tmp_System.map; then
228 echo >&2 Inconsistent kallsyms data
229 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
230 cleanup
231 exit 1
235 # We made a new kernel - delete old version file
236 rm -f .old_version